Dim oGroup
Dim oCluster, oClusterName, oEnv
Dim oResource
Dim testsrvs, prodsrvs, smon, i
smon = "VBECS Service Monitor"
prodsrvs = Array("VBECS Scheduled Report Runner", "VBECS HL7 Multi Listener", "VBECS CPRS HL7 Client Monitor", "VBECS VistALink RPC XML Listener")
testsrvs = Array("VBECS Test Scheduled Report Runner", "VBECS Test HL7 Multi Listener", "VBECS Test CPRS HL7 Client Monitor", "VBECS Test VistALink RPC XML Listener")

On Error Goto 0 

QuitWithErrorIfNotCSript()
if WScript.Arguments.Count < 2 then 
	WScript.Echo "Wrong number of command line arguments. Please provide cluster name and VBECS environment"
	WScript.Quit(1)
end if


WScript.Quit( DoProcessClusterGroupCreation() )


private function DoProcessClusterGroupCreation()
  Dim srvs
	oClusterName = WScript.Arguments(0)
  if IsNull(WScript.Arguments(1)) = true then
	  	WScript.Echo "Wrong VBECS environment specifyed. Please specify prod, test or sm"
	  	return 1
	end if
	oEnv = UCase(WScript.Arguments(1))
	if oEnv = "PROD" then
	  srvs = prodsrvs
	end if
	if oEnv = "TEST" then
	  srvs = testsrvs
	end if
  if oEnv = "SM" then
	  srvs = Array(smon)
	end if
	
	' Create the Cluster object.
	Set oCluster = CreateObject( "MSCluster.Cluster" )
	' Open the cluster. Empty string means open the local cluster.
	oCluster.Open( oClusterName )
	' Create or open the group.
	AddGroup oCluster, oEnv, oGroup
	For i = 0 To UBound(srvs)
		' Create or open the resource.
    AddResource oGroup, oResource, srvs( i )
	Next
end function

Sub AddGroup( oCluster, oEnv, oGroup )
    Set oGroup = oCluster.ResourceGroups.CreateItem( "VBECS Group " + oEnv )
End Sub

Sub AddResource( oGroup, oResource, Service )
    Dim oGroupResources
    Dim oProperties
    Dim oCLProperty
    Dim oCDPropery

    Set oGroupResources = oGroup.Resources
    Set oResource = oGroupResources.CreateItem( Service, "Generic Service", 0 ) 'CLUSTER_RESOURCE_DEFAULT_MONITOR
    Set oProperties = oResource.PrivateProperties

    ' Set the properties of the Generic Application
    oProperties.Item("ServiceName") = Service
    'oProperties.Item("StartupParameters")
    'oProperties.Item("UseNetworkName")
    oProperties.SaveChanges
End Sub

private sub QuitWithErrorIfNotCSript()
	If IsCscript() Then exit sub
	WScript.Echo "Please run this script from a command line using cscript."
	WScript.Quit(1)	
end sub

private function IsCscript()
  IsCscript = False

  If InStrRev(LCase(WScript.FullName), "cscript.exe", -1) Then
    IsCscript = True
  End If
end function    